rem - program UCRF.BAS
rem - Update Cash Record File
rem - revised 06/25/1982
rem - variable tabulation ************************
rem   a   = transaction amount
rem   a$  = transaction amount input
rem   a1$ = account name 1
rem   a2$ = account name 2
rem   a3$ = account name 3
rem   b1  = account 1 balance
rem   b2  = account 2 balance
rem   b3  = account 3 balance
rem   c   = transaction code
rem   c1$ = account number
rem   c2$ = transaction type
rem   d$  = transaction description
rem   e1  = input error
rem   i%  = for next loop counter
rem   n   = transaction number
rem   n$  = transaction number input
rem   p   = page counter
rem   p$  = transaction date
rem   p1$ = month
rem   p2$ = day
rem   p3$ = year
rem   q$  = continuation input question
rem   q2$ = correct data question
rem   q3$ = item correction question
rem   s1  = end switch
rem   s2  = first pass switch
rem   t   = tax percentage on transaction
rem   t$  = tax percentage input
rem   v   = transaction verification code
rem   x   = numeric check counter
rem   x$  = numeric check equivalent 
rem   y   = decimal place counter
rem   z   = numeric match counter
rem - program structure **************************
gosub 100 : rem - housekeeping
10 if s1=1 then 20
gosub 200 : rem - processing
goto 10
20 gosub 1600 : rem - end of job
chain "SSPM"
100 rem - housekeeping subroutine ********************
dim d$(25)
let s2=1
print chr$(27)+")";
print chr$(27)+"="+chr$(49)+chr$(38);
print "Searching for end of file - please wait"
print chr$(27)+"(";
open "B:SDF.DAT" as 1
read #1;a1$,b1,a2$,b2,a3$,b3
close 1
open "B:CSF.DAT" as 1
if end #1 then 190
110 read #1; n,p$,c,d$,a,v,t
if end #1 then 180
goto 110
180 let v=0
190 return
200 rem - process subroutine *********************
if s2=1 then gosub 300 : rem - screen
if s2=0 then gosub 400 : rem - clear
let s2=0
gosub 500 : rem - input
print #1; n,p$,c,d$,a,v,t
return
300 rem screen subroutine ************************
print chr$(26)
print chr$(27)+")";
print tab(2);"CHECKBOOK REGISTER UPDATE";
print tab(36);"Entry No: ";tab(46);" ";
let p=p+1
print using "##";p
print
print tab(1);" ";
for i%=1 to 48
print "-";
next i%
print
print tab(27);"(1)";tab(47);"(2)"
print tab(2);"Transaction Number: ";
print tab(33);"Date: "
print tab(27);"(3)"
print tab(4);"Transaction Code: "
print tab(27);"(4)"
print tab(9);"Description: "
print tab(27);"(5)";tab(47);"(6)"
print tab(2);"Transaction Amount: ";
print tab(35);"Tax Rate: ";tab(49);"%"
print
print tab(1);" ";
for i%=1 to 48
print "-";
next i%
print
print
print tab(2);"Accounts: ";"1 = ";a1$;" 2 = ";a2$;
print " 3 = ";a3$
print
print tab(2);"Transaction Type: ";
print tab(21);"D = Deposit";tab(36);"W = Withdrawal"
print chr$(27)+"(";
return
400 rem - clear subroutine ***********************
print chr$(27)+"="+chr$(38)+chr$(53);
for i%=1 to 9
print " ";
next i%
print chr$(27)+"="+chr$(38)+chr$(71);
for i%=1 to 10
print " ";
next i%
print
print chr$(27)+"="+chr$(40)+chr$(53);
for i%=1 to 27
print " ";
next i%
print
print chr$(27)+"="+chr$(42)+chr$(53);
for i%=1 to 27
print " ";
next i%
print
print chr$(27)+"="+chr$(44)+chr$(53);
for i%=1 to 9
print " ";
next i%
print chr$(27)+"="+chr$(44)+chr$(78);
print "  "
print chr$(27)+"="+chr$(34)+chr$(78);
print "  ";
let p=p+1
print chr$(27)+"="+chr$(34)+chr$(78);
print using "##";p
return
500 rem - input subroutine ***********************
gosub 600 : rem - trans number
gosub 800 : rem - date
gosub 1000 : rem - code
gosub 1100 : rem - description
gosub 1200 : rem - amount
gosub 1300 : rem - tax rate
gosub 1400 : rem - verify
510 gosub 1500 : rem - cursor
input "Do you wish to continue (y/n) >";q1$
let q1$=ucase$(q1$)
if q1$<>"Y" and q1$<>"N" then 510
if q1$="Y" then 590
let s1=1
590 return
600 rem - trans number subroutine ****************
610 gosub 1500 : rem - cursor
input "Enter transaction number >";n$
if len(n$)>9 then 620
goto 630
620 gosub 1500 : rem - cursor
print chr$(27)+")";
print "Error - number too long; 9 digits max!!!"
print tab(1);" ";
input "Press - RETURN - to retry >";line q$
print chr$(27)+"(";
goto 610
630 let x$=n$
gosub 700 : rem - numeric check
if e1=0 then 640
goto 610
640 print chr$(27)+"="+chr$(38)+chr$(53);
print n$
let n=val(n$)
return
700 rem - numeric check subroutine ***************
let e1=0
let x=0
let y=0
let z=0
let y=y+match(".",x$,1)
for i%=1 to len(x$)
let z=z+i%
next i%
if y=0 then 710
let z=z+1
710 for i%=1 to len(x$)
let x=x+match("#",x$,i%)
next i%
if x=z then 790
let e1=1
gosub 1500 : rem - cursor
print chr$(27)+")";
print "Error - non numeric data!!!"
print tab(1);" ";
input "Press - RETURN - to retry >";line q$
print chr$(27)+"(";
790 return
800 rem - date subroutine ************************
810 gosub 1500 : rem cursor
input "Enter transaction date (MM/DD/YYYY) >";p$
gosub 900 : rem - date verification
if e1=0 then 820
goto 810
820 print chr$(27)+"="+chr$(38)+chr$(71);
print p$
return
900 rem - date verification subroutine ***********
let e1=0
if len(p$)>10 then 910
let x=0
for i%=1 to 10
let x=x+match("#",p$,i%)
next i%
if x<>57 then 910
let p1$=left$(p$,2)
let p2$=mid$(p$,4,2)
let p3$=right$(p$,4)
if val(p1$)<1 then 910
if val(p1$)>12 then 910
if val(p2$)<1 then 910
if val(p3$)<1 then 910
if val(p1$)=9 and val(p2$)>30 then 910
if val(p1$)=4 and val(p2$)>30 then 910
if val(p1$)=6 and val(p2$)>30 then 910
if val(p1$)=11 and val(p2$)>30 then 910
if val(p1$)=2 and val(p2$)>29 then 910
if val(p3$)/4=int(val(p3$)/4) then 990
if val(p1$)=2 and val(p2$)>28 then 910
goto 990
910 gosub 1500 : rem - cursor
print chr$(27)+")";
print "Error - improper date!!!"
print tab(1);" ";
input "Press - RETURN - to retry >";line q$
print chr$(27)+"(";
let e1=1
990 return
1000 rem - code subroutine ***********************
1010 gosub 1500 : rem - cursor
input "Enter account number from above >";c1$
let x$=c1$
gosub 700
if e1=1 then 1010
if val(c1$)<>int(val(c1$)) then 1020
if val(c1$)>0 and val(c1$)<4 then 1030
1020 gosub 1500 : rem - cursor
print chr$(27)+")";
input "Error!!! Press - RETURN - to retry >";line q$
print chr$(27)+"(";
goto 1010
1030 gosub 1500 : rem - cursor
input "Enter transaction type from above >";c2$
let c2$=ucase$(c2$)
if c2$<>"D" and c2$<>"W" then 1020
if c2$="D" then 1040
if c2$="W" then 1070
1040 if val(c1$)<>1 then 1050
let c=1
goto 1080
1050 if val(c1$)<>2 then 1060
let c=3
goto 1080
1060 let c=5
goto 1080
1070 let c=val(c1$)*2
1080 print chr$(27)+"="+chr$(40)+chr$(53);
if c=1 then print a1$;" DEPOSIT"
if c=2 then print a1$;" WITHDRAWAL"
if c=3 then print a2$;" DEPOSIT"
if c=4 then print a2$;" WITHDRAWAL"
if c=5 then print a3$;" DEPOSIT"
if c=6 then print a3$;" WITHDRAWAL"
return
1100 rem - description subroutine ****************
1110 gosub 1500 : rem - cursor
input "Enter description >";d$
let d$=ucase$(d$)
if len(d$)<26 then 1120
gosub 1500 : rem - cursor
print chr$(27)+")";
print "Error - description too long!!!"
print tab(1);" ";
input "Press - RETURN - to retry >";line q$
print chr$(27)+"(";
1120 print chr$(27)+"="+chr$(42)+chr$(53);
print d$
return
1200 rem - amount subroutine *********************
1210 gosub 1500 : rem - cursor
input "Enter transaction amount >";a$
if len(a$)<10 then 1220
gosub 1500 : rem - cursor
print chr$(27)+")";
print "Error - amount too large!!!"
print tab(1);" ";
input "Press - RETURN - to retry >";line q$
print chr$(27)+"(";
goto 1210
1220 let x$=a$
gosub 700 : rem - numeric check
if e1=1 then 1210
print chr$(27)+"="+chr$(44)+chr$(53);
let a=val(a$)
print using "######.##";a
return
1300 rem - tax rate subroutine *******************
1310 gosub 1500 : rem - cursor
input "Enter sales tax rate as XX % >";t$
let t$=left$(t$,2)
let x$=t$
gosub 700 : rem - numeric check
if e1=1 then 1310
print chr$(27)+"="+chr$(44)+chr$(76);
let t=val(t$)
print using "###";t
return
1400 rem - verify subroutine *********************
1410 gosub 1500
input "Is all data above correct (y/n) >";q2$
let q2$=ucase$(q2$)
if q2$<>"Y" and q2$<>"N" then 1410
if q2$="Y" then 1490
1420 gosub 1500 : rem - cursor
input "Enter number of item to correct >";q3$
gosub 700 : rem - numeric check
if e1=1 then 1420
if val(q3$)>0 and val(q3$)<7 then 1440
goto 1420
if val(q3$)=int(val(q3$)) then 1440
goto 1420
1440 on val(q3$) gosub 600,800,1000,1100,1200,1300
goto 1410
1490 return
1500 rem - cursor subroutine *********************
print chr$(27)+"="+chr$(53)+chr$(33);
print chr$(27)+"R";
print chr$(27)+"="+chr$(54)+chr$(33);
print chr$(27)+"R";
print chr$(27)+"="+chr$(53)+chr$(33);
return
1600 rem - end of job subroutine *****************
close 1
return
